# 16.5 不需要将一个指向切片的指针传递给函数

在第 [4.9 小节](04.9.md)，我们已经知道，切片实际是一个指向潜在数组的指针。我们常常需要把切片作为一个参数传递给函数是因为：实际就是传递一个指向变量的指针，在函数内可以改变这个变量，而不是传递数据的拷贝。

因此应该这样做：

```go
       func findBiggest( listOfNumbers []int ) int {}
```

而不是：

```go
       func findBiggest( listOfNumbers *[]int ) int {}
```

**当切片作为参数传递时，切记不要解引用切片。**

## 链接

- [目录](directory.md)
- 上一节：[何时使用 new() 和 make()](16.4.md)
- 下一节：[使用指针指向接口类型](16.6.md)
